package se.salomonsson;

import se.salomonsson.g2d.DrawableText;
import se.salomonsson.g2d.GameThread;
import se.salomonsson.g2d.GameView;
import se.salomonsson.test.TestFPS;
import se.salomonsson.test.TestObj;
import android.app.Activity;
import android.os.Bundle;
import android.util.Log;

/**
 * http://www.droidnova.com/playing-with-graphics-in-android-part-i,147.html
 * http://www.droidnova.com/2d-sprite-animation-in-android,471.html
 * @author Tommislav
 */

public class MainActivity extends Activity {
    
		private GameThread mThread;
	
		/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        GameView gv = new GameView(this);
        setContentView(gv);
        
        Log.i("tommy", "onCreate");
        mThread = new GameThread(gv);
        
        TestObj obj = new TestObj(10,10,1);
        mThread.addUpdateable(obj);
        mThread.addRenderable(obj);
        
        obj = new TestObj(20,50,11);
        mThread.addUpdateable(obj);
        mThread.addRenderable(obj);
        
        mThread.addRenderable(new DrawableText("TEST", 0f, 10f));
        mThread.addRenderable(new TestFPS("", 0f, 25f));
    }
    
    @Override
    protected void onPause() {
    	Log.i("tommy", "onPause");
    	mThread.stop();
    	super.onPause();
    }
    
    @Override
    protected void onResume() {
    	Log.i("tommy", "onResume");
    	mThread.start();
    	super.onResume();
    }
    
}