package se.salomonsson.g2d;

public class Dim {
	private final int mX;
	private final int mY;
	private final int mW;
	private final int mH;
	
	public Dim(int x, int y, int w, int h)
	{
		mX = x;
		mY = y;
		mW = w;
		mH = h;
	}
	
	public final int getX() { return mX; }
	public final int getY() { return mY; }
	public final int getW() { return mW; }
	public final int getH()	{ return mH; }
	
	public final boolean isEmpty() { return (mX == 0 && mY == 0 && mW == 0 && mH == 0); }
	public final boolean equals(Dim otherDim)
	{
		if (otherDim == null)
			return false;
		
		return (otherDim.getX() == mX && otherDim.getY() == mY && otherDim.getW() == mW && otherDim.getH() == mH);
	}
	
	@Override
	public String toString() {
		return "Dim x=" + mX + ",y=" + mY + ",w=" + mW + ",h=" + mH;
	}
}
