package se.salomonsson.observer;

import java.util.ArrayList;

// Simple observer implementation
public class Observable {

	private ArrayList<IObserver> mObservables;
	private ArrayList<IObserver> mSingleDispatchObservables;
	
	
	public Observable()
	{
		mObservables = new ArrayList<IObserver>();
		mSingleDispatchObservables = new ArrayList<IObserver>();
	}
	
	public void add(IObserver obs)
	{
		if ( mObservables.indexOf(obs) == -1 )
			mObservables.add(obs);
	}
	
	public void addOnce(IObserver obs)
	{
		if (mSingleDispatchObservables.indexOf(obs) == -1)
			mSingleDispatchObservables.add(obs);
	}
	
	public void remove(IObserver obs)
	{
		mObservables.remove(obs);
		mSingleDispatchObservables.remove(obs);
	}
	
	public void removeAll()
	{
		mObservables = new ArrayList<IObserver>();
		mSingleDispatchObservables = new ArrayList<IObserver>();
	}
	
	public void dispatch()
	{
		ArrayList<IObserver> copy = new ArrayList<IObserver>();
		copy.addAll(mObservables);
		copy.addAll(mSingleDispatchObservables);
		
		int i = 0;
		int len = copy.size();
		
		for (i=0; i<len; i++)
		{
			copy.get(i).onNotify();
		}
	}
}
