package se.salomonsson.test;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import se.salomonsson.g2d.IRenderable;
import se.salomonsson.g2d.IUpdateable;

public class TestObj implements IRenderable, IUpdateable {

	private Paint mPaint;
	private Rect mRect;
	private int mXdir;
	private int mYdir;
	
	public TestObj( int x, int y, int speed )
	{
		mPaint = new Paint();
		mPaint.setARGB(155, 155, 155, 155);
		mRect = new Rect(x,y,x+100,y+100);
		mXdir = speed;
		mYdir = speed;
	}
	
	@Override
	public void update(Rect camera) {
		int w = camera.width();
		int h = camera.height();
		
		int left = mRect.left + mXdir;
		int right = left + 100;
		int top = mRect.top + mYdir;
		int bottom = top + 100;
		
		mRect.set(left, top, right, bottom);
		if ( mRect.right > w || mRect.left < 0 )
			mXdir *= -1;
		
		if ( mRect.bottom > h || mRect.top < 0 )
			mYdir *= -1;
	}

	@Override
	public void render(Canvas canvas, Rect camera) {
		canvas.drawRect(mRect, mPaint);
	}

}
